function IQAuthRedirectsAdd(pop, itemid) {
	pop = pop === undefined ? 1 : pop;
	itemid = itemid === undefined ? 0 : itemid;
	let pretag = '';
	if(pop) {
		pretag = 'pop_';
	}
	
	IQ_AUTH_Loader(1);
	jQuery.ajax({
		type: "POST",
		url: iq_auth_redirects_unique.ajax_url,
		data:{'action':'admin_iq_auth_RedirectsAdd',
		'ItemID':itemid,
		'Pop':pop},
		success: function(data) {
			IQ_AUTH_Loader(0);
			
			let phtml = jQuery.parseHTML( data );
			let result = jQuery(phtml).filter("#pop").length;
			if(result) {
				if(!document.getElementById('modal')) {
					jQuery(document.body).append('<div id="modal"></div>');
				}
				
				jQuery('#modal').html(data);
				setTimeout(function(){
					jQuery('#pop_modal').addClass('pop_show');
					PopOutClose();
				}, 100);
				return true;
			}
			IQ_AUTH_NoticeStrErr('notice_block', 'err', data);
		}
	});
}

function IQAuthRedirectsAddDo(pop, item) {
	pop = pop === undefined ? 0 : pop;
	item = item === undefined ? 0 : item;
	let pretag = '';
	if(pop) {
		pretag = 'pop_';
	}
	
	const block_form = pretag+'form_data';
	const block_options = pretag+'block_options';
	const block_notice = pretag+'red_notice_block';
	if(!document.getElementById(block_form)) {
		return;
	}
	
	if(!document.getElementById(pretag+'json_data') ||
	!document.getElementById(pretag+'sign_data')) {
		return;
	}
	const json_data = jQuery('#'+pretag+'json_data').val();
	const sign_data = jQuery('#'+pretag+'sign_data').val();
	
	let data = new FormData();
	data.append('action', 'admin_iq_auth_RedirectsAddDo');
	
	data.append('JsonData', json_data);
	data.append('SignData', sign_data);
	
	let FormValues = [];
	let OptionValues = [];
	let value;
	jQuery('#'+block_form).find('select, input, textarea').each(function(){
		FormValues.push(this.id);
		if(jQuery(this).attr('type') == 'checkbox') {
			value = jQuery(this).is(':checked');
		} else {
			value = jQuery(this).val();
		}
		data.append( this.id, value );
	});
	data.append('Values', FormValues);
	data.append('Pop', pop);
	
	IQ_AUTH_Loader(true);
	let ajax = new XMLHttpRequest();
	ajax.onload = ajax.onerror = function() {
		IQ_AUTH_Loader(false);
		if(!document.getElementById(block_form)) {
			return;
		}
		
		const phtml = jQuery.parseHTML( this.responseText );
		if(this.status == 200) {
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				// success
				if(item) {
					IQAuthRedirectsItemReload(item);
				} else {
					location.reload();
				}
				PopClose();
				return true;
			}
		}
		IQ_AUTH_NoticeStrErr(block_notice, 'err', this.responseText);
	}
	ajax.open("POST", iq_auth_redirects_unique.ajax_url, true);
	ajax.send(data);
}

function IQAuthRedirectsDelete(item) {
	if(item <= 0) {
		return false;
	}
	
	if(!confirm('Are you sure you want to delete')) {
		return false;
	}
	
	IQ_AUTH_Loader(true);
	jQuery.ajax({
		type: "POST",
		url: iq_auth_redirects_unique.ajax_url,
		data:{'action':'admin_iq_auth_RedirectsItemDelete',
		'ItemID':item},
		success: function(data) {
			IQ_AUTH_Loader(false);
			
			let phtml = jQuery.parseHTML( data );
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				if(document.getElementById('item_block_'+item)) {
					jQuery('#item_block_'+item).fadeOut(200);
					setTimeout(function(){
						jQuery('#item_block_'+item).remove();
					}, 200);
				}
				return true;
			}
			IQ_AUTH_NoticeStrErr('notice_block', 'err', data);
		}
	});
}
				
function IQAuthRedirectsItemReload(item) {
	if(item <= 0) {
		return false;
	}
	
	const block = 'item_block_'+item;
	if(!document.getElementById(block)) {
		return false;
	}
	jQuery('#'+block).css('opacity', 0.5);
	
	jQuery.ajax({
		type: "POST",
		url: iq_auth_redirects_unique.ajax_url,
		data:{'action':'admin_iq_auth_RedirectsItemReload',
		'ItemID':item},
		success: function(data) {
			if(!document.getElementById(block)) {
				return false;
			}
			
			if(data) {
				const el_temp = document.getElementById(block);
				el_temp.insertAdjacentHTML('afterEnd', data);
				el_temp.remove();
			}
		}
	});
}