<?php
if(isset($_POST['action'])) {
	$AjaxRequest = true;
} else {
	$AjaxRequest = false;
	if(!defined("IQ_AUTH_CORE_DIR")) { die(); }
}

$DataValuesArr = [];
if($AjaxRequest) {
	if(!isset($_SERVER['HTTP_REFERER'])) {
		die();
	}
	sleep(1);
	
	if(!isset($_POST['Values'])) {
		die();
	}
	
	$bPop = false;
	if(isset($_POST['Pop'])) {
		$bPop = (int)sanitize_text_field($_POST['Pop']);
	}
	if($bPop) {
		$szPreTag = 'pop_';
	} else {
		$szPreTag = '';
	}
	
	#######################
	##### DATA VALUES #####
	#######################
	$DataJsonStrArr = array();
	$PostValues = sanitize_text_field($_POST['Values']);
	$Exp = explode(',', $PostValues);
	$ArrayData = array();
	for($i = 0; $i < count($Exp); $i++) {
		$TempParam = trim($Exp[$i]);
		if(empty($TempParam)) { continue; }
		$ArrayData[] = $TempParam;
	}

	if(empty($ArrayData)) {
		die();
	}
	
	// json_data
	$Key = $szPreTag.'json_data';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['json_data'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['json_data'])) {
		$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
		die($szMsg);
	}
	
	// sign_data
	$Key = $szPreTag.'sign_data';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['sign_data'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['sign_data'])) {
		$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
		die($szMsg);
	}
	
	// iq_pass
	$Key = $szPreTag.'iq_pass';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter your new password', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_pass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_pass'])) {
		$szMsg = esc_html__('Enter your new password', 'registration-and-authorize');
		die($szMsg);
	}
	
	// iq_repass
	$Key = $szPreTag.'iq_repass';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter password repeat', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_repass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_repass'])) {
		$szMsg = esc_html__('Enter password repeat', 'registration-and-authorize');
		die($szMsg);
	}
	
	if($DataValuesArr['iq_pass'] != $DataValuesArr['iq_repass']) {
		$szMsg = esc_html__('Password mismatch', 'registration-and-authorize');
		die($szMsg);
	}
	
} else {
	
	// json_data
	$Key = $szPreTag.'json_data';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('An error has occurred', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['json_data'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['json_data'])) {
		$szErr = esc_html__('An error has occurred', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	// sign_data
	$Key = $szPreTag.'sign_data';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('An error has occurred', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['sign_data'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['sign_data'])) {
		$szErr = esc_html__('An error has occurred', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	// iq_pass
	$Key = $szPreTag.'iq_pass';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter your new password', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_pass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_pass'])) {
		$szErr = esc_html__('Enter your new password', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	// iq_repass
	$Key = $szPreTag.'iq_repass';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter password repeat', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_repass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_repass'])) {
		$szErr = esc_html__('Enter password repeat', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	if($DataValuesArr['iq_pass'] != $DataValuesArr['iq_repass']) {
		$szErr = esc_html__('Password mismatch', 'registration-and-authorize');
		$bErr = true;
		return;
	}
}

// Protect
$JsonProtect = sanitize_text_field($DataValuesArr['json_data']);
$SignCheck = func_iq_auth_get_sign_json_array_protect($JsonProtect);
$szPostSign = sanitize_text_field($DataValuesArr['sign_data']);
if($szPostSign != $SignCheck) { die(); }
$JsonVal = func_iq_auth_out_protect($JsonProtect);

########################
##### DATA PROTECT #####
########################
$CArr = json_decode($JsonVal, true);
if(empty($CArr)) {
	return false;
}

// recover_email
if(!isset($CArr['recover_email']) || empty($CArr['recover_email'])) {
	$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
	if($AjaxRequest) {
		echo esc_html($szMsg);
		die();
	}
	$szErr = $szMsg;
	$bErr = true;
	return;
}
$CArr['recover_email'] = sanitize_email($CArr['recover_email']);

if(!isset($iq_auth_settings_arr)) {
	$iq_auth_settings_arr = func_iq_auth_get_settings();
}

$redirect_url = '/';
if(isset($iq_auth_settings_arr['auth_redirect'])) {
	$redirect_url = '/'.$iq_auth_settings_arr['auth_redirect'];
}
if(isset($iq_auth_settings_arr['lost_url'])) {
	$lost_url = '/'.$iq_auth_settings_arr['lost_url'];
} else {
	$lost_url = '/'.IQ_AUTH_LOST_PAGE_DEF;
}

######################
##### VALIDATION #####
######################
// def inputs
$DefArr['pass'] = [
	'name' => esc_html__('Password', 'registration-and-authorize'),
	'regex' => '/^[A-Za-z0-9_\-\.]+$/',
	'min' => 2,
	'max' => 64,
];

$FormVal = [];

$bSkip = false;
foreach($DefArr AS $key => $data) {
	$FormVal[$key.'_length'] = $data['min'].':'.$data['max'];
	if(isset($iq_auth_settings_arr[$key.'_length'])) {
		$FormVal[$key.'_length'] = $iq_auth_settings_arr[$key.'_length'];
	}
	$Exp = explode(':', $FormVal[$key.'_length']);
	$FormVal[$key.'_length_min'] = (int)$Exp[0];
	$FormVal[$key.'_length_max'] = (int)$Exp[1];
	
	$KeyPost = 'iq_'.$key;
	if(func_iq_auth_get_count_letter($DataValuesArr['iq_'.$key]) < $FormVal[$key.'_length_min'] || func_iq_auth_get_count_letter($DataValuesArr['iq_'.$key]) > $FormVal[$key.'_length_max']) {
		$szMsg = sprintf(esc_html__('The length of the «%s» field must be between %s and %s characters', 'registration-and-authorize'), $data['name'], $FormVal[$key.'_length_min'], $FormVal[$key.'_length_max']);
		
		if($AjaxRequest) {
			echo esc_html($szMsg);
			die();
		}
		$szErr = $szMsg;
		$bErr = true;
		$bSkip = true;
	}
	if($bSkip) {
		break;
	}
	
	// regex
	$FormVal[$key.'_regex'] = '';
	if(isset($iq_auth_settings_arr[$key.'_regex'])) {
		$FormVal[$key.'_regex'] = stripcslashes($iq_auth_settings_arr[$key.'_regex']);
	}
	if(!empty($FormVal[$key.'_regex'])) {
		if(preg_match($FormVal[$key.'_regex'], $DataValuesArr['iq_'.$key]) !== 1) {
			if(isset($iq_auth_settings_arr[$key.'_regex_text']) && !empty($iq_auth_settings_arr[$key.'_regex_text'])) {
				$szMsg = stripcslashes($iq_auth_settings_arr[$key.'_regex_text']);
			} else {
				$szMsg = sprintf(esc_html__('Incorrect field value «%s»', 'registration-and-authorize'), $data['name']);
			}
			if($AjaxRequest) {
				echo esc_html($szMsg);
				die();
			}
			$szErr = $szMsg;
			$bErr = true;
			
			$bSkip = true;
		}
	}
	if($bSkip) {
		break;
	}
}
if($bSkip) { 
	return;
}
	
if ( is_user_logged_in() ) {
	if($AjaxRequest) {
		?>
		<div id="auth_already">
			<input type="hidden" id="temp_redirect_url" value="<?php echo esc_attr($redirect_url); ?>">
			<?php echo esc_html__('You are already logged in', 'registration-and-authorize'); ?>
		</div>
		<?php
		die();
	}
	wp_redirect($redirect_url);
	return;
}

if(!isset($cIQAuthClass)) {
	require_once IQ_AUTH_CORE_DIR.'/includes/inc_auth.php';
	$cIQAuthClass = new IQAuthClass();
}

###################
##### CAPTCHA #####
###################
$service_lost = 'lost_try';
$bCaptcha = false;
$bCaptchaShow = false;
if(isset($iq_auth_settings_arr['lost_captcha_enable']) && (int)$iq_auth_settings_arr['lost_captcha_enable']) {
	if(isset($iq_auth_settings_arr['captcha_pub']) && !empty($iq_auth_settings_arr['captcha_pub']) && isset($iq_auth_settings_arr['captcha_secret']) && !empty($iq_auth_settings_arr['captcha_secret'])) {
		$bCaptcha = true;
	}
}

$iCaptchaLimitFree = 0;
if($bCaptcha) {
	if(isset($iq_auth_settings_arr['captcha_limit_free']) && (int)$iq_auth_settings_arr['captcha_limit_free']) {
		$iCaptchaLimitFree = (int)$iq_auth_settings_arr['captcha_limit_free'];
		$iCountTry = $cIQAuthClass->antifloodGetCount($service_lost);
		if($iCountTry >= (int)$iCaptchaLimitFree) {
			$bCaptchaShow = true;
		}
	} else {
		// Always
		$bCaptchaShow = true;
	}
}

if($bCaptcha && $bCaptchaShow) {
	// Show captcha
	$capcha_key = false;
	if($AjaxRequest) {
		foreach($ArrayData AS $key) {
			if(strpos($key, 'g-recaptcha-response') !== false) {
				if(isset($_POST[$key])) {
					$capcha_key = $key;
					break;
				}
			}
		}
	} else {
		foreach($_POST AS $key => $post_data) {
			if(strpos($key, 'g-recaptcha-response') !== false) {
				$capcha_key = $key;
				break;
			}
		}
	}
	if(!$capcha_key) {
		if($AjaxRequest) {
			?>
			<div id="captcha_block" class="iq_auth_align_center">
				<center>
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="<?php echo esc_attr($iq_auth_settings_arr['captcha_pub']); ?>"></div>
				</center>
			</div>
			<?php
			die();
		}
		$bCapcha = true;
		$bErr = true;
		return;
	}
	
	$response_key = sanitize_text_field($_POST[$capcha_key]);
	
	$secretKey = $iq_auth_settings_arr['captcha_secret'];
	$ip = $_SERVER['REMOTE_ADDR'];
	$url = 'https://www.google.com/recaptcha/api/siteverify?secret=' . urlencode($secretKey) .  '&response=' . urlencode($response_key);
	$response = file_get_contents($url);
	$responseKeys = json_decode($response,true);
	if(!$responseKeys["success"]) {
		if($AjaxRequest) {
			?>
			<div id="captcha_block" class="iq_auth_align_center">
				<center>
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="<?php echo esc_attr($iq_auth_settings_arr['captcha_pub']); ?>"></div>
				</center>
			</div>
			<?php
			die();
		}
		$bCapcha = true;
		$bErr = true;
		return;
	}
	if($iCaptchaLimitFree) {
		$cIQAuthClass->antifloodRemove($service_lost);
	}
}

if($bCaptcha && !$bCaptchaShow && $iCaptchaLimitFree) {
	$cIQAuthClass->antifloodAdd($service_lost);
}

if( !email_exists($CArr['recover_email']) ) {
	$szMsg = esc_html__('There is no account for the specified email. Make sure you entered your email correctly', 'registration-and-authorize');
	if($AjaxRequest) {
		die($szMsg);
	}
	$szErr = $szMsg;
	$bErr = true;
	return;
}

#######################
##### GET USER_ID #####
#######################
$user_obj = get_user_by( 'email', $CArr['recover_email'] );
if(!$user_obj) {
	$szMsg = esc_html__('There is no account for the specified email. Make sure you entered your email correctly', 'registration-and-authorize');
	if($AjaxRequest) {
		die($szMsg);
	}
	$szErr = $szMsg;
	$bErr = true;
	return;
}

#######################
##### CHANGE_PASS #####
#######################
wp_set_password($DataValuesArr['iq_pass'], $user_obj->data->ID);

######################
##### TRY LOGGIN #####
######################
// Success
$credentials = [
	'user_login' => $CArr['recover_email'],
	'user_password' => $DataValuesArr['iq_pass'],
	'rememberme' => true,
];
$signon = wp_signon($credentials, true);
if(is_wp_error($signon)){
	$szMsg = esc_html__('An error has occurred', 'registration-and-authorize').'000';
	if($AjaxRequest) {
		die($szMsg);
	}
	$szErr = $szMsg;
	$bErr = true;
	return;
}
$AuthObj = wp_authenticate( $CArr['recover_email'], $DataValuesArr['iq_pass'] );
$AuthArr = (array)$AuthObj;
if(isset($AuthArr['data'])) {
	if($AjaxRequest) {
		?>
		<div id="success">
			<input type="hidden" id="temp_redirect_url" value="<?php echo esc_url($redirect_url); ?>">
			<?php echo esc_html__('Password changed successfully', 'registration-and-authorize'); ?>
		</div>
		
		<?php
		die();
	}
	wp_redirect($redirect_url);
	return;
}

$szMsg = esc_html__('An error has occurred', 'registration-and-authorize').'111';
if($AjaxRequest) {
	echo esc_html($szErr);
	die();
}
$szErr = $szMsg;
$bErr = true;
return;
?>