<?php
if(isset($_POST['action'])) {
	$AjaxRequest = true;
} else {
	$AjaxRequest = false;
	if(!defined("IQ_AUTH_CORE_DIR")) { die(); }
}

$DataValuesArr = [];
if($AjaxRequest) {
	if(!isset($_SERVER['HTTP_REFERER'])) {
		die();
	}
	sleep(1);
	
	if(!isset($_POST['Values'])) {
		die();
	}
	
	$bPop = false;
	if(isset($_POST['Pop'])) {
		$bPop = (int)sanitize_text_field($_POST['Pop']);
	}
	if($bPop) {
		$szPreTag = 'pop_';
	} else {
		$szPreTag = '';
	}
	
	#######################
	##### DATA VALUES #####
	#######################
	$DataJsonStrArr = array();
	$PostValues = sanitize_text_field($_POST['Values']);
	$Exp = explode(',', $PostValues);
	$ArrayData = array();
	for($i = 0; $i < count($Exp); $i++) {
		$TempParam = trim($Exp[$i]);
		if(empty($TempParam)) { continue; }
		$ArrayData[] = $TempParam;
	}

	if(empty($ArrayData)) {
		die();
	}
	
	// iq_login
	$Key = $szPreTag.'iq_login';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter the desired login', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_login'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_login'])) {
		$szMsg = esc_html__('Enter the desired login', 'registration-and-authorize');
		die($szMsg);
	}
	
	// iq_email
	$Key = $szPreTag.'iq_email';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter email', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_email'] = sanitize_email($_POST[$Key]);
	if(empty($DataValuesArr['iq_email'])) {
		$szMsg = esc_html__('Enter email', 'registration-and-authorize');
		die($szMsg);
	}
	
	// iq_pass
	$Key = $szPreTag.'iq_pass';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter your desired password', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_pass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_pass'])) {
		$szMsg = esc_html__('Enter your desired password', 'registration-and-authorize');
		die($szMsg);
	}
	
	// iq_repass
	$Key = $szPreTag.'iq_repass';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter password repeat', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_repass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_repass'])) {
		$szMsg = esc_html__('Enter password repeat', 'registration-and-authorize');
		die($szMsg);
	}
	
	if($DataValuesArr['iq_pass'] != $DataValuesArr['iq_repass']) {
		$szMsg = esc_html__('Password mismatch', 'registration-and-authorize');
		die($szMsg);
	}
} else {
	// iq_login
	$Key = $szPreTag.'iq_login';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter the desired login', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_login'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_login'])) {
		$szErr = esc_html__('Enter the desired login', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	// iq_email
	$Key = $szPreTag.'iq_email';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter email', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_email'] = sanitize_email($_POST[$Key]);
	if(empty($DataValuesArr['iq_email'])) {
		$szErr = esc_html__('Enter email', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	// iq_pass
	$Key = $szPreTag.'iq_pass';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter your desired password', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_pass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_pass'])) {
		$szErr = esc_html__('Enter your desired password', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	// iq_repass
	$Key = $szPreTag.'iq_repass';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter password repeat', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_repass'] = sanitize_text_field($_POST[$Key]);
	if(empty($DataValuesArr['iq_repass'])) {
		$szErr = esc_html__('Enter password repeat', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	
	if($DataValuesArr['iq_pass'] != $DataValuesArr['iq_repass']) {
		$szErr = esc_html__('Password mismatch', 'registration-and-authorize');
		$bErr = true;
		return;
	}
}

if(!isset($iq_auth_settings_arr)) {
	$iq_auth_settings_arr = func_iq_auth_get_settings();
}

$redirect_url = '/';
if(isset($iq_auth_settings_arr['auth_redirect'])) {
	$redirect_url = '/'.$iq_auth_settings_arr['auth_redirect'];
}

######################
##### VALIDATION #####
######################
// def inputs
$DefArr['login'] = [
	'name' => esc_html__('Login', 'registration-and-authorize'),
	'regex' => '/^(?=.*[A-Za-zА-Яа-яёґєії0-9])[A-Za-zА-Яа-яёґєії][A-Za-zА-Яа-яёґєії\d .-]{0,19}$/',
	'min' => 2,
	'max' => 64,
];
$DefArr['email'] = [
	'name' => 'Email',
	'regex' => '/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/',
	'min' => 2,
	'max' => 64,
];
$DefArr['pass'] = [
	'name' => esc_html__('Password', 'registration-and-authorize'),
	'regex' => '/^[A-Za-z0-9_\-\.]+$/',
	'min' => 2,
	'max' => 64,
];

$FormVal = [];

$bSkip = false;
foreach($DefArr AS $key => $data) {
	$FormVal[$key.'_length'] = $data['min'].':'.$data['max'];
	if(isset($iq_auth_settings_arr[$key.'_length'])) {
		$FormVal[$key.'_length'] = $iq_auth_settings_arr[$key.'_length'];
	}
	$Exp = explode(':', $FormVal[$key.'_length']);
	$FormVal[$key.'_length_min'] = (int)$Exp[0];
	$FormVal[$key.'_length_max'] = (int)$Exp[1];
	
	$KeyPost = 'iq_'.$key;
	if(func_iq_auth_get_count_letter($DataValuesArr['iq_'.$key]) < $FormVal[$key.'_length_min'] || func_iq_auth_get_count_letter($DataValuesArr['iq_'.$key]) > $FormVal[$key.'_length_max']) {
		$szMsg = sprintf(esc_html__('The length of the «%s» field must be between %s and %s characters', 'registration-and-authorize'), $data['name'], $FormVal[$key.'_length_min'], $FormVal[$key.'_length_max']);
		
		if($AjaxRequest) {
			echo esc_html($szMsg);
			die();
		}
		$szErr = $szMsg;
		$bErr = true;
		$bSkip = true;
	}
	if($bSkip) {
		break;
	}
	
	// regex
	$FormVal[$key.'_regex'] = '';
	if(isset($iq_auth_settings_arr[$key.'_regex'])) {
		$FormVal[$key.'_regex'] = stripcslashes($iq_auth_settings_arr[$key.'_regex']);
	}
	if(!empty($FormVal[$key.'_regex'])) {
		if(preg_match($FormVal[$key.'_regex'], $DataValuesArr['iq_'.$key]) !== 1) {
			if(isset($iq_auth_settings_arr[$key.'_regex_text']) && !empty($iq_auth_settings_arr[$key.'_regex_text'])) {
				$szMsg = stripcslashes($iq_auth_settings_arr[$key.'_regex_text']);
			} else {
				$szMsg = sprintf(esc_html__('Incorrect field value «%s»', 'registration-and-authorize'), $data['name']);
			}
			if($AjaxRequest) {
				echo esc_html($szMsg);
				die();
			}
			$szErr = $szMsg;
			$bErr = true;
			
			$bSkip = true;
		}
	}
	if($bSkip) {
		break;
	}
}
if($bSkip) { 
	return;
}
	
if ( is_user_logged_in() ) {
	if($AjaxRequest) {
		?>
		<div id="auth_already">
			<input type="hidden" id="temp_redirect_url" value="<?php echo esc_attr($redirect_url); ?>">
			<?php echo esc_html__('You are already logged in', 'registration-and-authorize'); ?>
		</div>
		<?php
		die();
	}
	wp_redirect($redirect_url);
	return;
}

if(!isset($cIQAuthClass)) {
	require_once IQ_AUTH_CORE_DIR.'/includes/inc_auth.php';
	$cIQAuthClass = new IQAuthClass();
}

###################
##### CAPTCHA #####
###################
$service_regist = 'regist_try';
$bCaptcha = false;
$bCaptchaShow = false;
if(isset($iq_auth_settings_arr['regist_captcha_enable']) && (int)$iq_auth_settings_arr['regist_captcha_enable']) {
	if(isset($iq_auth_settings_arr['captcha_pub']) && !empty($iq_auth_settings_arr['captcha_pub']) && isset($iq_auth_settings_arr['captcha_secret']) && !empty($iq_auth_settings_arr['captcha_secret'])) {
		$bCaptcha = true;
	}
}

$iCaptchaLimitFree = 0;
if($bCaptcha) {
	if(isset($iq_auth_settings_arr['captcha_limit_free']) && (int)$iq_auth_settings_arr['captcha_limit_free']) {
		$iCaptchaLimitFree = (int)$iq_auth_settings_arr['captcha_limit_free'];
		$iCountTry = $cIQAuthClass->antifloodGetCount($service_regist);
		if($iCountTry >= (int)$iCaptchaLimitFree) {
			$bCaptchaShow = true;
		}
	} else {
		// Always
		$bCaptchaShow = true;
	}
}

if($bCaptcha && $bCaptchaShow) {
	// Show captcha
	$capcha_key = false;
	if($AjaxRequest) {
		foreach($ArrayData AS $key) {
			if(strpos($key, 'g-recaptcha-response') !== false) {
				if(isset($_POST[$key])) {
					$capcha_key = $key;
					break;
				}
			}
		}
	} else {
		foreach($_POST AS $key => $post_data) {
			if(strpos($key, 'g-recaptcha-response') !== false) {
				$capcha_key = $key;
				break;
			}
		}
	}
	if(!$capcha_key) {
		if($AjaxRequest) {
			?>
			<div id="captcha_block" class="iq_auth_align_center">
				<center>
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="<?php echo esc_attr($iq_auth_settings_arr['captcha_pub']); ?>"></div>
				</center>
			</div>
			<?php
			die();
		}
		$bCapcha = true;
		$bErr = true;
		return;
	}
	
	$response_key = sanitize_text_field($_POST[$capcha_key]);
	
	$secretKey = $iq_auth_settings_arr['captcha_secret'];
	$ip = $_SERVER['REMOTE_ADDR'];
	$url = 'https://www.google.com/recaptcha/api/siteverify?secret=' . urlencode($secretKey) .  '&response=' . urlencode($response_key);
	$response = file_get_contents($url);
	$responseKeys = json_decode($response,true);
	if(!$responseKeys["success"]) {
		if($AjaxRequest) {
			?>
			<div id="captcha_block" class="iq_auth_align_center">
				<center>
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="<?php echo esc_attr($iq_auth_settings_arr['captcha_pub']); ?>"></div>
				</center>
			</div>
			<?php
			die();
		}
		$bCapcha = true;
		$bErr = true;
		return;
	}
	if($iCaptchaLimitFree) {
		$cIQAuthClass->antifloodRemove($service_regist);
	}
}

if($bCaptcha && !$bCaptchaShow && $iCaptchaLimitFree) {
	$cIQAuthClass->antifloodAdd($service_regist);
}

#########################
##### CUSTOM FIELDS #####
#########################
$custom_values_data_user_arr = [];
if(func_iq_auth_module_enable('custom_fields')) {
	include IQ_AUTH_CUSTOM_FIELDS_DIR.'/includes/data_custom_field_regist_do.php';
}
if($bSkip) { 
	return;
}


#########################
##### EMAIL CONFIRM #####
#########################
if(isset($iq_auth_settings_arr['email_confirm']) && (int)$iq_auth_settings_arr['email_confirm']) {
	if(isset($iq_auth_settings_arr['email_confirm_length']) && (int)$iq_auth_settings_arr['email_confirm_length']) {
		$iCodeLength = (int)$iq_auth_settings_arr['email_confirm_length'];
	} else {
		$iCodeLength = 6;
	}
	
	if(isset($iq_auth_settings_arr['email_confirm_tries_max'])) {
		$iTriesMax = (int)$iq_auth_settings_arr['email_confirm_tries_max'];
	} else {
		$iTriesMax = 5;
	}
	
	$szPH = '';
	for($i = 0; $i < $iCodeLength; $i++) {
		$szPH .= '0';
	}
	
	// Send code
	$DataValuesArr['iq_code'] = '';
	$Key = $szPreTag.'iq_code';
	if($AjaxRequest) {
		if(in_array($Key, $ArrayData) && isset($_POST[$Key])) {
			$DataValuesArr['iq_code'] = sanitize_text_field($_POST[$Key]);
		}
	} else {
		if(isset($_POST[$Key]) && !empty($_POST[$Key])) {
			$DataValuesArr['iq_code'] = sanitize_text_field($_POST[$Key]);
		}
	}
	
	$service = 'confirm_regist';
	
	if($iTriesMax) {
		// Checking for simulated input attempts
		$iTriesCount = $cIQAuthClass->antifloodGetCount($service);
		if($iTriesCount >= $iTriesMax) {
			$DataValuesArr['iq_code'] = '';
			$cIQAuthClass->antifloodRemove($service);
			$cIQAuthClass->codeRemove($service, $DataValuesArr['iq_email']);
		}
	}
	
	$code_already = $cIQAuthClass->codeGetAlready($service, $DataValuesArr['iq_email']);
	if(!empty($DataValuesArr['iq_code'])) {
		// check validate code
		if($iTriesMax) {
			$iTriesCount++;
		}
		if($code_already != $DataValuesArr['iq_code']) {
			if($iTriesMax) {
				// add trie
				$cIQAuthClass->antifloodAdd($service);
			}
			?>
				<div id="confirm_block" class="iq_auth_align_center">
					<div class="iq_auth_alert_block iq_auth_err">
						<?php echo esc_html__('The entered code is not correct', 'registration-and-authorize'); ?>
						<?php if($iTriesMax) { ?>
							<?php echo esc_html__('Attempts', 'registration-and-authorize'); ?>: <?php echo esc_html('['.$iTriesCount.'/'.$iTriesMax.']'); ?>
						<?php } ?>
					</div>
					<div class="iq_auth_padd_5">
						<input type="text" id="<?php echo esc_html($szPreTag . 'iq_code'); ?>" name="<?php echo esc_html($szPreTag . 'iq_code'); ?>" class="iq_auth_input iq_auth_input_default iq_auth_align_center iq_auth_block_centered" maxlength="<?php echo esc_attr($iCodeLength); ?>" placeholder="<?php echo esc_attr($szPH); ?>">
					</div>
				</div>
			<?php
			if($AjaxRequest) {
				die();
			}
			return;
		}
		$cIQAuthClass->codeRemove($service, $DataValuesArr['iq_email']);
	} else {
		// send code
		if(!$code_already) {
			$szCode = func_iq_auth_gen_pass($iCodeLength);
			$result = $cIQAuthClass->codeSend($service, $DataValuesArr['iq_email'], $szCode);
		
			if(!$result) {
				$szMsg = esc_html__('Failed to send enrollment confirmation code. Contact support', 'registration-and-authorize');
				if($AjaxRequest) {
					die($szMsg);
				}
				$szErr = $szMsg;
				$bErr = true;
				
				return;
			}
			
			$szTheme = esc_html__('Registration confirmation code', 'registration-and-authorize');
			if(isset($iq_auth_settings_arr['email_confirm_message']) && (int)$iq_auth_settings_arr['email_confirm_message']) {
			} else {
				$iq_auth_settings_arr['email_confirm_message'] = esc_html__('Hello! Your account verification code: {CODE}. Enter it in the input field on the registration page', 'registration-and-authorize');
			}
			$email_message = str_replace("{CODE}", $szCode, $iq_auth_settings_arr['email_confirm_message']);
	
			// send email
			$email = get_option('admin_email');
			$headers = 'From: '. $email . "\r\n" .
				'Reply-To: ' . $email . "\r\n";
		
			$result = wp_mail(
				trim($DataValuesArr['iq_email']),
				$szTheme,
				strip_tags($email_message), 
				$headers
			);
			
			if(!$result) {
				$szMsg = esc_html__('Failed to send enrollment confirmation code. Contact support', 'registration-and-authorize');
				if($AjaxRequest) {
					die($szMsg);
				}
				$szErr = $szMsg;
				$bErr = true;
				
				return;
			}
		}
		
		?>
			<div id="confirm_block" class="iq_auth_align_center">
				<div class="iq_auth_li_head">
					<?php if($code_already) { ?>
						<?php echo sprintf(esc_html__('Recently, a message with an account verification code was sent to «%s». Please check to see if it ended up in your spam folder by mistake.', 'registration-and-authorize'), $DataValuesArr['iq_email']); ?>
					<?php } else { ?>
						<?php echo sprintf(esc_html__('A registration confirmation code has been sent to email «%s». Please enter it in the input field. The message may end up in the Spam folder by mistake, please check this folder and make sure that the message is not there', 'registration-and-authorize'), $DataValuesArr['iq_email']); ?>
					<?php } ?>
				</div>
				<div class="iq_auth_padd_5">
					<input type="text" id="<?php echo esc_html($szPreTag . 'iq_code'); ?>" name="<?php echo esc_html($szPreTag . 'iq_code'); ?>" class="iq_auth_input iq_auth_input_default iq_auth_align_center iq_auth_block_centered" maxlength="<?php echo esc_attr($iCodeLength); ?>" placeholder="<?php echo esc_attr($szPH); ?>">
				</div>
			</div>
		<?php
		if($AjaxRequest) {
			die();
		}
		return;
	}
}

$user_id = wp_create_user( $DataValuesArr['iq_login'], $DataValuesArr['iq_pass'], $DataValuesArr['iq_email'] );
if(is_integer($user_id)) {
	// Create IQ user
	$result = $cIQAuthClass->createUser($user_id, $custom_values_data_user_arr);
	
	// Success
	$credentials = [
		'user_login' => $DataValuesArr['iq_login'],
		'user_password' => $DataValuesArr['iq_pass'],
		'rememberme' => true,
	];
	$signon = wp_signon($credentials, true);
	if(is_wp_error($signon)){
		echo esc_html__('Wrong login or password', 'registration-and-authorize');
		if($AjaxRequest) {
			die();
		}
		return;
	}
	$AuthObj = wp_authenticate( $DataValuesArr['iq_login'], $DataValuesArr['iq_pass'] );
	$AuthArr = (array)$AuthObj;
	if(isset($AuthArr['data'])) {
		if($AjaxRequest) {
			?>
			<div id="success">
				<input type="hidden" id="temp_redirect_url" value="<?php echo esc_url($redirect_url); ?>">
				<?php echo esc_html__('You have successfully registered', 'registration-and-authorize'); ?>
			</div>
			
			<?php
			die();
		}
		wp_redirect($redirect_url);
		return;
	}
}

$AuthRegist = (array)$user_id;
if(isset($AuthRegist['errors'])) {
	foreach($AuthRegist['errors'] AS $key => $data) {
		$szErr = esc_html($data[0]);
		$bErr = true;
		break;
	}
}
if(empty($szErr)) {
	$szErr = esc_html__('Registration error', 'registration-and-authorize');
}
if($AjaxRequest) {
	echo esc_html($szErr);
	die();
}
$bErr = true;
return;
?>