<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}

?>
<div class="iq_auth_wizard_step">
	<div class="iq_auth_wizard_atitle">
		<?php echo esc_html__('Setup completed', 'registration-and-authorize'); ?>
		
	</div>
	<div class="iq_auth_wizard_body">
		<div>
			<div class="iq_auth_wizard_block_centered iq_auth_wizard_align_center">
				<?php
				$img_url = IQ_AUTH_WIZARD_URL . '/assets/img/iq_settings.png';
				?>
				<img src="<?php echo esc_url($img_url); ?>" class="iq_auth_wizard_img_okey">
			</div>
			<div class="iq_auth_wizard_atitle">
				<?php echo esc_html__('Great', 'registration-and-authorize'); ?>!
			</div>
			<div class="iq_auth_wizard_deftxt">
				<?php echo esc_html__('You can make other settings on the IQ Authorization page', 'registration-and-authorize'); ?><br>
				<?php echo esc_html__('Enjoy using', 'registration-and-authorize'); ?>
			</div>
		</div>
	</div>
	<div id="notice_form_data"></div>
	<div class="iq_auth_wizard_ablock_btn">
		<div class="iq_auth_wizard_btns_line">
			<a href="/wp-admin/admin.php?page=iq-auth-wizard&step=2" class="iq_auth_wizard_btn_back iq_auth_wizard_f1">
				<?php echo esc_html__('Come back', 'registration-and-authorize'); ?>
			</a>
			<a class="iq_auth_wizard_abutton iq_auth_wizard_f2" href="/wp-admin/admin.php?page=iq-auth-settings-page">
				<?php echo esc_html__('Finish', 'registration-and-authorize'); ?>
			</a>
			<a class="iq_auth_wizard_btn_skip iq_auth_wizard_f1" href="/wp-admin/admin.php?page=iq-auth-settings-page">
				<?php echo esc_html__('Skip', 'registration-and-authorize'); ?>
			</a>
		</div>
	</div>
</div>